//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: bitsong/auction/v1beta1/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query defines the gRPC querier service for Auction Module
///
/// Usage: instantiate `Bitsong_Auction_V1beta1_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Bitsong_Auction_V1beta1_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Bitsong_Auction_V1beta1_QueryClientInterceptorFactoryProtocol? { get }

  func auction(
    _ request: Bitsong_Auction_V1beta1_QueryAuctionRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Bitsong_Auction_V1beta1_QueryAuctionRequest, Bitsong_Auction_V1beta1_QueryAuctionResponse>

  func allAuctions(
    _ request: Bitsong_Auction_V1beta1_QueryAllAuctionsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Bitsong_Auction_V1beta1_QueryAllAuctionsRequest, Bitsong_Auction_V1beta1_QueryAllAuctionsResponse>

  func auctionsByOwner(
    _ request: Bitsong_Auction_V1beta1_QueryAuctionsByOwnerRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Bitsong_Auction_V1beta1_QueryAuctionsByOwnerRequest, Bitsong_Auction_V1beta1_QueryAuctionsByOwnerResponse>

  func bids(
    _ request: Bitsong_Auction_V1beta1_QueryBidsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Bitsong_Auction_V1beta1_QueryBidsRequest, Bitsong_Auction_V1beta1_QueryBidsResponse>
}

extension Bitsong_Auction_V1beta1_QueryClientProtocol {
  internal var serviceName: String {
    return "bitsong.auction.v1beta1.Query"
  }

  /// Auction queries the Auction for the given id
  ///
  /// - Parameters:
  ///   - request: Request to send to Auction.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func auction(
    _ request: Bitsong_Auction_V1beta1_QueryAuctionRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Bitsong_Auction_V1beta1_QueryAuctionRequest, Bitsong_Auction_V1beta1_QueryAuctionResponse> {
    return self.makeUnaryCall(
      path: "/bitsong.auction.v1beta1.Query/Auction",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeAuctionInterceptors() ?? []
    )
  }

  /// AllAuctions queries the all Auctions
  ///
  /// - Parameters:
  ///   - request: Request to send to AllAuctions.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func allAuctions(
    _ request: Bitsong_Auction_V1beta1_QueryAllAuctionsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Bitsong_Auction_V1beta1_QueryAllAuctionsRequest, Bitsong_Auction_V1beta1_QueryAllAuctionsResponse> {
    return self.makeUnaryCall(
      path: "/bitsong.auction.v1beta1.Query/AllAuctions",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeAllAuctionsInterceptors() ?? []
    )
  }

  /// AuctionsByOwner queries the Auctions of the given owner
  ///
  /// - Parameters:
  ///   - request: Request to send to AuctionsByOwner.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func auctionsByOwner(
    _ request: Bitsong_Auction_V1beta1_QueryAuctionsByOwnerRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Bitsong_Auction_V1beta1_QueryAuctionsByOwnerRequest, Bitsong_Auction_V1beta1_QueryAuctionsByOwnerResponse> {
    return self.makeUnaryCall(
      path: "/bitsong.auction.v1beta1.Query/AuctionsByOwner",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeAuctionsByOwnerInterceptors() ?? []
    )
  }

  /// Bids queries the bids of the given auction id
  ///
  /// - Parameters:
  ///   - request: Request to send to Bids.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func bids(
    _ request: Bitsong_Auction_V1beta1_QueryBidsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Bitsong_Auction_V1beta1_QueryBidsRequest, Bitsong_Auction_V1beta1_QueryBidsResponse> {
    return self.makeUnaryCall(
      path: "/bitsong.auction.v1beta1.Query/Bids",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeBidsInterceptors() ?? []
    )
  }
}

internal protocol Bitsong_Auction_V1beta1_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'auction'.
  func makeAuctionInterceptors() -> [ClientInterceptor<Bitsong_Auction_V1beta1_QueryAuctionRequest, Bitsong_Auction_V1beta1_QueryAuctionResponse>]

  /// - Returns: Interceptors to use when invoking 'allAuctions'.
  func makeAllAuctionsInterceptors() -> [ClientInterceptor<Bitsong_Auction_V1beta1_QueryAllAuctionsRequest, Bitsong_Auction_V1beta1_QueryAllAuctionsResponse>]

  /// - Returns: Interceptors to use when invoking 'auctionsByOwner'.
  func makeAuctionsByOwnerInterceptors() -> [ClientInterceptor<Bitsong_Auction_V1beta1_QueryAuctionsByOwnerRequest, Bitsong_Auction_V1beta1_QueryAuctionsByOwnerResponse>]

  /// - Returns: Interceptors to use when invoking 'bids'.
  func makeBidsInterceptors() -> [ClientInterceptor<Bitsong_Auction_V1beta1_QueryBidsRequest, Bitsong_Auction_V1beta1_QueryBidsResponse>]
}

internal final class Bitsong_Auction_V1beta1_QueryClient: Bitsong_Auction_V1beta1_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Bitsong_Auction_V1beta1_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the bitsong.auction.v1beta1.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Bitsong_Auction_V1beta1_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query defines the gRPC querier service for Auction Module
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Bitsong_Auction_V1beta1_QueryProvider: CallHandlerProvider {
  var interceptors: Bitsong_Auction_V1beta1_QueryServerInterceptorFactoryProtocol? { get }

  /// Auction queries the Auction for the given id
  func auction(request: Bitsong_Auction_V1beta1_QueryAuctionRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Bitsong_Auction_V1beta1_QueryAuctionResponse>

  /// AllAuctions queries the all Auctions
  func allAuctions(request: Bitsong_Auction_V1beta1_QueryAllAuctionsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Bitsong_Auction_V1beta1_QueryAllAuctionsResponse>

  /// AuctionsByOwner queries the Auctions of the given owner
  func auctionsByOwner(request: Bitsong_Auction_V1beta1_QueryAuctionsByOwnerRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Bitsong_Auction_V1beta1_QueryAuctionsByOwnerResponse>

  /// Bids queries the bids of the given auction id
  func bids(request: Bitsong_Auction_V1beta1_QueryBidsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Bitsong_Auction_V1beta1_QueryBidsResponse>
}

extension Bitsong_Auction_V1beta1_QueryProvider {
  internal var serviceName: Substring { return "bitsong.auction.v1beta1.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "Auction":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Bitsong_Auction_V1beta1_QueryAuctionRequest>(),
        responseSerializer: ProtobufSerializer<Bitsong_Auction_V1beta1_QueryAuctionResponse>(),
        interceptors: self.interceptors?.makeAuctionInterceptors() ?? [],
        userFunction: self.auction(request:context:)
      )

    case "AllAuctions":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Bitsong_Auction_V1beta1_QueryAllAuctionsRequest>(),
        responseSerializer: ProtobufSerializer<Bitsong_Auction_V1beta1_QueryAllAuctionsResponse>(),
        interceptors: self.interceptors?.makeAllAuctionsInterceptors() ?? [],
        userFunction: self.allAuctions(request:context:)
      )

    case "AuctionsByOwner":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Bitsong_Auction_V1beta1_QueryAuctionsByOwnerRequest>(),
        responseSerializer: ProtobufSerializer<Bitsong_Auction_V1beta1_QueryAuctionsByOwnerResponse>(),
        interceptors: self.interceptors?.makeAuctionsByOwnerInterceptors() ?? [],
        userFunction: self.auctionsByOwner(request:context:)
      )

    case "Bids":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Bitsong_Auction_V1beta1_QueryBidsRequest>(),
        responseSerializer: ProtobufSerializer<Bitsong_Auction_V1beta1_QueryBidsResponse>(),
        interceptors: self.interceptors?.makeBidsInterceptors() ?? [],
        userFunction: self.bids(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Bitsong_Auction_V1beta1_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'auction'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeAuctionInterceptors() -> [ServerInterceptor<Bitsong_Auction_V1beta1_QueryAuctionRequest, Bitsong_Auction_V1beta1_QueryAuctionResponse>]

  /// - Returns: Interceptors to use when handling 'allAuctions'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeAllAuctionsInterceptors() -> [ServerInterceptor<Bitsong_Auction_V1beta1_QueryAllAuctionsRequest, Bitsong_Auction_V1beta1_QueryAllAuctionsResponse>]

  /// - Returns: Interceptors to use when handling 'auctionsByOwner'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeAuctionsByOwnerInterceptors() -> [ServerInterceptor<Bitsong_Auction_V1beta1_QueryAuctionsByOwnerRequest, Bitsong_Auction_V1beta1_QueryAuctionsByOwnerResponse>]

  /// - Returns: Interceptors to use when handling 'bids'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeBidsInterceptors() -> [ServerInterceptor<Bitsong_Auction_V1beta1_QueryBidsRequest, Bitsong_Auction_V1beta1_QueryBidsResponse>]
}
