//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: sentinel/provider/v1/querier.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Usage: instantiate `Sentinel_Provider_V1_QueryServiceClient`, then call methods of this protocol to make API calls.
internal protocol Sentinel_Provider_V1_QueryServiceClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Sentinel_Provider_V1_QueryServiceClientInterceptorFactoryProtocol? { get }

  func queryProviders(
    _ request: Sentinel_Provider_V1_QueryProvidersRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Sentinel_Provider_V1_QueryProvidersRequest, Sentinel_Provider_V1_QueryProvidersResponse>

  func queryProvider(
    _ request: Sentinel_Provider_V1_QueryProviderRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Sentinel_Provider_V1_QueryProviderRequest, Sentinel_Provider_V1_QueryProviderResponse>

  func queryParams(
    _ request: Sentinel_Provider_V1_QueryParamsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Sentinel_Provider_V1_QueryParamsRequest, Sentinel_Provider_V1_QueryParamsResponse>
}

extension Sentinel_Provider_V1_QueryServiceClientProtocol {
  internal var serviceName: String {
    return "sentinel.provider.v1.QueryService"
  }

  /// Unary call to QueryProviders
  ///
  /// - Parameters:
  ///   - request: Request to send to QueryProviders.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func queryProviders(
    _ request: Sentinel_Provider_V1_QueryProvidersRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Sentinel_Provider_V1_QueryProvidersRequest, Sentinel_Provider_V1_QueryProvidersResponse> {
    return self.makeUnaryCall(
      path: "/sentinel.provider.v1.QueryService/QueryProviders",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeQueryProvidersInterceptors() ?? []
    )
  }

  /// Unary call to QueryProvider
  ///
  /// - Parameters:
  ///   - request: Request to send to QueryProvider.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func queryProvider(
    _ request: Sentinel_Provider_V1_QueryProviderRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Sentinel_Provider_V1_QueryProviderRequest, Sentinel_Provider_V1_QueryProviderResponse> {
    return self.makeUnaryCall(
      path: "/sentinel.provider.v1.QueryService/QueryProvider",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeQueryProviderInterceptors() ?? []
    )
  }

  /// Unary call to QueryParams
  ///
  /// - Parameters:
  ///   - request: Request to send to QueryParams.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func queryParams(
    _ request: Sentinel_Provider_V1_QueryParamsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Sentinel_Provider_V1_QueryParamsRequest, Sentinel_Provider_V1_QueryParamsResponse> {
    return self.makeUnaryCall(
      path: "/sentinel.provider.v1.QueryService/QueryParams",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeQueryParamsInterceptors() ?? []
    )
  }
}

internal protocol Sentinel_Provider_V1_QueryServiceClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'queryProviders'.
  func makeQueryProvidersInterceptors() -> [ClientInterceptor<Sentinel_Provider_V1_QueryProvidersRequest, Sentinel_Provider_V1_QueryProvidersResponse>]

  /// - Returns: Interceptors to use when invoking 'queryProvider'.
  func makeQueryProviderInterceptors() -> [ClientInterceptor<Sentinel_Provider_V1_QueryProviderRequest, Sentinel_Provider_V1_QueryProviderResponse>]

  /// - Returns: Interceptors to use when invoking 'queryParams'.
  func makeQueryParamsInterceptors() -> [ClientInterceptor<Sentinel_Provider_V1_QueryParamsRequest, Sentinel_Provider_V1_QueryParamsResponse>]
}

internal final class Sentinel_Provider_V1_QueryServiceClient: Sentinel_Provider_V1_QueryServiceClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Sentinel_Provider_V1_QueryServiceClientInterceptorFactoryProtocol?

  /// Creates a client for the sentinel.provider.v1.QueryService service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Sentinel_Provider_V1_QueryServiceClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// To build a server, implement a class that conforms to this protocol.
internal protocol Sentinel_Provider_V1_QueryServiceProvider: CallHandlerProvider {
  var interceptors: Sentinel_Provider_V1_QueryServiceServerInterceptorFactoryProtocol? { get }

  func queryProviders(request: Sentinel_Provider_V1_QueryProvidersRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Sentinel_Provider_V1_QueryProvidersResponse>

  func queryProvider(request: Sentinel_Provider_V1_QueryProviderRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Sentinel_Provider_V1_QueryProviderResponse>

  func queryParams(request: Sentinel_Provider_V1_QueryParamsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Sentinel_Provider_V1_QueryParamsResponse>
}

extension Sentinel_Provider_V1_QueryServiceProvider {
  internal var serviceName: Substring { return "sentinel.provider.v1.QueryService" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "QueryProviders":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Sentinel_Provider_V1_QueryProvidersRequest>(),
        responseSerializer: ProtobufSerializer<Sentinel_Provider_V1_QueryProvidersResponse>(),
        interceptors: self.interceptors?.makeQueryProvidersInterceptors() ?? [],
        userFunction: self.queryProviders(request:context:)
      )

    case "QueryProvider":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Sentinel_Provider_V1_QueryProviderRequest>(),
        responseSerializer: ProtobufSerializer<Sentinel_Provider_V1_QueryProviderResponse>(),
        interceptors: self.interceptors?.makeQueryProviderInterceptors() ?? [],
        userFunction: self.queryProvider(request:context:)
      )

    case "QueryParams":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Sentinel_Provider_V1_QueryParamsRequest>(),
        responseSerializer: ProtobufSerializer<Sentinel_Provider_V1_QueryParamsResponse>(),
        interceptors: self.interceptors?.makeQueryParamsInterceptors() ?? [],
        userFunction: self.queryParams(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Sentinel_Provider_V1_QueryServiceServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'queryProviders'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeQueryProvidersInterceptors() -> [ServerInterceptor<Sentinel_Provider_V1_QueryProvidersRequest, Sentinel_Provider_V1_QueryProvidersResponse>]

  /// - Returns: Interceptors to use when handling 'queryProvider'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeQueryProviderInterceptors() -> [ServerInterceptor<Sentinel_Provider_V1_QueryProviderRequest, Sentinel_Provider_V1_QueryProviderResponse>]

  /// - Returns: Interceptors to use when handling 'queryParams'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeQueryParamsInterceptors() -> [ServerInterceptor<Sentinel_Provider_V1_QueryParamsRequest, Sentinel_Provider_V1_QueryParamsResponse>]
}
